Your search did not match any results.

JavaScript/jQuery Chat - Edit and Delete Messages

The DevExtreme JavaScript Chat allows users to edit and delete messages as needs dictate.

Use a data source to allow users to edit and delete messages. DevExtreme JavaScript Chat does not update the data source automatically. Implement a CustomStore with CRUD operations to handle updates. Once you configured these operations, enable editing.

Backend API
$(() => { const customStore = new DevExpress.data.CustomStore({ key: 'id', load: async () => messages, insert: async (message) => { messages.push(message); return message; }, }); const dataSource = new DevExpress.data.DataSource({ store: customStore, paginate: false, }); const chat = $('#chat').dxChat({ height: 600, dataSource, editing: { allowUpdating: true, allowDeleting: true, }, reloadOnChange: false, user: currentUser, onMessageEntered(e) { const { message } = e; dataSource.store().push([{ type: 'insert', data: { id: new DevExpress.data.Guid(), ...message, }, }]); }, onMessageDeleted(e) { const { message } = e; dataSource.store().push([{ type: 'update', key: message.id, data: { isDeleted: true }, }]); }, onMessageUpdated(e) { const { message, text } = e; dataSource.store().push([{ type: 'update', key: message.id, data: { text, isEdited: true }, }]); }, }).dxChat('instance'); $('#allow-editing').dxSelectBox({ items: editingOptions, value: editingOptions[0].key, valueExpr: 'key', displayExpr: 'text', inputAttr: { 'aria-label': 'Allow Editing' }, onValueChanged(data) { chat.option('editing.allowUpdating', editingStrategy[data.value]); }, }); $('#allow-deleting').dxSelectBox({ items: editingOptions, value: editingOptions[0].key, valueExpr: 'key', displayExpr: 'text', inputAttr: { 'aria-label': 'Allow Deleting' }, onValueChanged(data) { chat.option('editing.allowDeleting', editingStrategy[data.value]); }, }); const editingStrategy = { enabled: true, disabled: false, custom: ({ component, message }) => { const { items, user } = component.option(); const userId = user.id; const lastNotDeletedMessage = items.findLast( (item) => item.author?.id === userId && !item.isDeleted, ); return message.id === lastNotDeletedMessage?.id; }, }; });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.8"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="chat-container"> <div id="chat"></div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Allow Editing:</span> <div id="allow-editing"></div> </div> <div class="option"> <span>Allow Deleting:</span> <div id="allow-deleting"></div> </div> </div> </div> </body> </html>
.demo-container { min-width: 720px; display: flex; gap: 20px; } .chat-container { display: flex; flex-grow: 1; align-items: center; justify-content: center; } .options { padding: 20px; display: flex; flex-direction: column; min-width: 280px; background-color: rgba(191, 191, 191, 0.15); gap: 16px; } .dx-chat { max-width: 480px; } .caption { font-size: var(--dx-font-size-sm); font-weight: 500; } .dx-avatar { border: 1px solid var(--dx-color-border); }
const getTimestamp = function (date, offsetMinutes = 0) { return date.getTime() + offsetMinutes * 60000; }; const date = new Date(); date.setHours(0, 0, 0, 0); const currentUser = { id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3', name: 'John Doe', }; const supportAgent = { id: 'd16d1a4c-5c67-4e20-b70e-2991c22747c3', name: 'Support Agent', avatarUrl: '../../../../images/petersmith.png', }; const messages = [ { id: new DevExpress.data.Guid(), timestamp: getTimestamp(date, -9), author: supportAgent, text: 'Hello, John!\nHow can I assist you today?', }, { id: new DevExpress.data.Guid(), timestamp: getTimestamp(date, -7), author: currentUser, text: "Hi, I'm having trouble accessing my account.", }, { id: new DevExpress.data.Guid(), timestamp: getTimestamp(date, -7), author: currentUser, text: 'It says my password is incorrect.', }, { id: new DevExpress.data.Guid(), timestamp: getTimestamp(date, -7), author: currentUser, isDeleted: true, }, { id: new DevExpress.data.Guid(), timestamp: getTimestamp(date, -7), author: supportAgent, text: 'I can help you with that. Can you please confirm your UserID for security purposes?', isEdited: true, }, ]; const editingOptions = [ { text: 'Enabled', key: 'enabled' }, { text: 'Disabled', key: 'disabled' }, { text: 'Only the last message (custom)', key: 'custom' }, ];

The editing object includes allowUpdating and allowDeleting properties. These Boolean options are initially set to false. To edit and delete messages, set these Boolean options to true or assign functions with custom logic.

Review this demo and learn how to delete/edit chat messages. First, ensure that "Options" are active in the panel next to the JavaScript Chat component. Right-click (Control+Click on MacOS) or long-tap a message to open the context menu. Select "Delete" to remove the message; a marker is then displayed in place of the deleted message within the feed. Choose "Edit" to view the original message and update its content. Click "Send" to save changes; this will mark the message as edited.

Backend API
<div class="demo-container">
<div class="chat-container">
<dx-chat
#chat
[height]="600"
[dataSource]="dataSource"
[reloadOnChange]="false"
[user]="currentUser"
(onMessageEntered)="onMessageEntered($event)"
(onMessageDeleted)="onMessageDeleted($event)"
(onMessageUpdated)="onMessageUpdated($event)"
>
<dxo-chat-editing
[allowUpdating]="allowUpdating"
[allowDeleting]="allowDeleting"
></dxo-chat-editing>
</dx-chat>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Allow Editing:</span>
<dx-select-box
[items]="editingStrategies"
displayExpr="text"
valueExpr="key"
[value]="selectedEditingStrategy"
[inputAttr]="alloUpdatingLabel"
(onValueChanged)="onAllowUpdatingChange($event)"
></dx-select-box>
</div>
<div class="option">
<span>Allow Deleting:</span>
<dx-select-box
[items]="editingStrategies"
displayExpr="text"
valueExpr="key"
[value]="selectedDeletingStrategy"
[inputAttr]="allowDeletingLabel"
(onValueChanged)="onAllowDeletingChange($event)"
></dx-select-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxChatModule, DxSelectBoxModule } from 'devextreme-angular';
import { type DxChatTypes } from 'devextreme-angular/ui/chat';
import { DataSource } from 'devextreme-angular/common/data';
import { AppService } from './app.service';
if (!document.location.host.includes('localhost')) {
enableProdMode();
}
let modulePrefix = '';
// @ts-expect-error
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxChatModule,
DxSelectBoxModule,
],
})
export class AppComponent {
currentUser: DxChatTypes.User;
allowUpdating = true;
allowDeleting = true;
editingStrategies = [
{ key: 'enabled', text: 'Enabled' },
{ key: 'disabled', text: 'Disabled' },
{ key: 'custom', text: 'Only the last message (custom)' },
];
dataSource: DataSource;
selectedEditingStrategy = 'enabled';
selectedDeletingStrategy = 'enabled';
allowEditingLabel = this.appService.allowEditingLabel;
allowDeletingLabel = this.appService.allowDeletingLabel;
editingStrategy: Record<string, any> = {
enabled: true,
disabled: false,
custom: ({ component, message }: any) => {
const { items, user } = component.option();
const userId = user.id;
const lastNotDeletedMessage = items.findLast(
(item: any) => item.author?.id === userId && !item.isDeleted
);
return message.id === lastNotDeletedMessage?.id;
},
};
constructor(private readonly appService: AppService) {
[this.currentUser] = this.appService.getUsers();
this.dataSource = this.appService.dataSource;
}
onMessageEntered(e: DxChatTypes.MessageEnteredEvent): void {
this.appService.onMessageEntered(e);
}
onMessageDeleted(e: DxChatTypes.MessageDeletedEvent): void {
this.appService.onMessageDeleted(e);
}
onMessageUpdated(e: DxChatTypes.MessageUpdatedEvent): void {
this.appService.onMessageUpdated(e);
}
onAllowUpdatingChange(event: any): void {
this.allowUpdating = this.editingStrategy[event.value];
this.selectedEditingStrategy = event.value;
}
onAllowDeletingChange(event: any): void {
this.allowDeleting = this.editingStrategy[event.value];
this.selectedDeletingStrategy = event.value;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
AppService,
],
});
.demo-container {
min-width: 720px;
display: flex;
gap: 20px;
}
::ng-deep .chat-container {
display: flex;
flex-grow: 1;
align-items: center;
justify-content: center;
}
::ng-deep .options {
padding: 20px;
display: flex;
flex-direction: column;
min-width: 280px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
::ng-deep .dx-chat {
max-width: 480px;
}
::ng-deep .caption {
font-size: var(--dx-font-size-sm);
font-weight: 500;
}
::ng-deep .dx-avatar {
border: 1px solid var(--dx-color-border);
}
import { type DxChatTypes } from 'devextreme-angular/ui/chat';
import { Guid } from 'devextreme-angular/common';
import { CustomStore, DataSource } from 'devextreme-angular/common/data';
export class AppService {
date: Date;
store: DxChatTypes.Message[] = [];
customStore: CustomStore;
dataSource: DataSource;
currentUser: DxChatTypes.User = {
id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3',
name: 'John Doe',
};
supportAgent: DxChatTypes.User = {
id: 'd16d1a4c-5c67-4e20-b70e-2991c22747c3',
name: 'Support Agent',
avatarUrl: '../../../../images/petersmith.png',
};
messages: DxChatTypes.Message[] = [];
allowEditingLabel = { 'aria-label': 'Allow Editing' };
allowDeletingLabel = { 'aria-label': 'Allow Deleting' };
constructor() {
this.date = new Date();
this.date.setHours(0, 0, 0, 0);
this.messages = [
{
id: new Guid().toString(),
timestamp: this.getTimestamp(this.date, -9),
author: this.supportAgent,
text: 'Hello, John!\nHow can I assist you today?',
},
{
id: new Guid().toString(),
timestamp: this.getTimestamp(this.date, -7),
author: this.currentUser,
text: 'Hi, I\'m having trouble accessing my account.',
},
{
id: new Guid().toString(),
timestamp: this.getTimestamp(this.date, -7),
author: this.currentUser,
text: 'It says my password is incorrect.',
},
{
id: new Guid().toString(),
timestamp: this.getTimestamp(this.date, -7),
author: this.currentUser,
isDeleted: true,
},
{
id: new Guid().toString(),
timestamp: this.getTimestamp(this.date, -7),
author: this.supportAgent,
text: 'I can help you with that. Can you please confirm your UserID for security purposes?',
isEdited: true,
},
];
this.initDataSource();
}
initDataSource() {
this.customStore = new CustomStore({
key: 'id',
load: () => this.messages,
insert: (message) => {
this.messages.push(message);
return message;
},
});
this.dataSource = new DataSource({
store: this.customStore,
paginate: false,
});
}
getUsers(): DxChatTypes.User[] {
return [this.currentUser, this.supportAgent];
}
getTimestamp(date: Date, offsetMinutes = 0): number {
return date.getTime() + offsetMinutes * 60000;
}
onMessageEntered({ message }: DxChatTypes.MessageEnteredEvent): void {
this.dataSource.store().push([{
type: 'insert',
data: {
id: new Guid().toString(),
...message,
},
}]);
}
onMessageDeleted({ message }: DxChatTypes.MessageDeletedEvent): void {
this.dataSource.store().push([{
type: 'update',
key: message.id,
data: { isDeleted: true },
}]);
}
onMessageUpdated({ message, text }: DxChatTypes.MessageUpdatedEvent): void {
this.dataSource.store().push([{
type: 'update',
key: message.id,
data: { text, isEdited: true },
}]);
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
The editing object includes allowUpdating and allowDeleting properties. These Boolean options are initially set to false. To edit and delete messages, set these Boolean options to true or assign functions with custom logic.
Review this demo and learn how to delete/edit chat messages. First, ensure that "Options" are active in the panel next to the Chat component. Right-click (Control+Click on MacOS) or long-tap a message to open the context menu. Select "Delete" to remove the message; a marker is then displayed in place of the deleted message within the feed. Choose "Edit" to view the original message and update its content. Click "Send" to save changes; this will mark the message as edited.

import React, { useState, useCallback } from 'react';
import { Chat, Editing, type ChatTypes } from 'devextreme-react/chat';
import { SelectBox } from 'devextreme-react/select-box';
import { Guid } from 'devextreme-react/common';
import { CustomStore, DataSource } from 'devextreme-react/common/data';
import {
currentUser,
messages as initialMessages,
allowEditingLabel,
allowDeletingLabel,
editingOptions,
} from './data.ts';
const editingStrategy = {
enabled: true,
disabled: false,
custom: ({ component, message }) => {
const { items, user } = component.option();
const userId = user.id;
const lastNotDeletedMessage = items.findLast((item) => item.author?.id === userId && !item.isDeleted);
return message.id === lastNotDeletedMessage?.id;
},
};
const store: ChatTypes.Message[] = [...initialMessages];
const customStore = new CustomStore({
key: 'id',
load: async () => store,
insert: async (message) => {
store.push(message);
return message;
},
});
const dataSource = new DataSource({
store: customStore,
paginate: false,
});
export default function App() {
const [allowUpdating, setAllowUpdating] = useState(true);
const [allowDeleting, setAllowDeleting] = useState(true);
const onMessageEntered = useCallback((
{ message }: ChatTypes.MessageEnteredEvent,
) => {
const newMessage = {
id: new Guid().toString(),
...message,
};
dataSource.store().push([{
type: 'insert',
key: newMessage.id,
data: newMessage,
}]);
}, []);
const onMessageDeleted = useCallback((
{ message }: ChatTypes.MessageDeletedEvent,
) => {
dataSource.store().push([{
type: 'update',
key: message.id,
data: { isDeleted: true },
}]);
}, []);
const onMessageUpdated = useCallback((
{ message, text }: ChatTypes.MessageUpdatedEvent,
) => {
dataSource.store().push([{
type: 'update',
key: message.id,
data: { text, isEdited: true },
}]);
}, []);
const handleAllowUpdatingChange = useCallback((e) => {
const strategy = editingStrategy[e.value];
setAllowUpdating(() => strategy);
}, []);
const handleAllowDeletingChange = useCallback((e) => {
const strategy = editingStrategy[e.value];
setAllowDeleting(() => strategy);
}, []);
return (
<React.Fragment>
<div className="chat-container">
<Chat
height={600}
dataSource={dataSource}
user={currentUser}
reloadOnChange={false}
onMessageEntered={onMessageEntered}
onMessageDeleted={onMessageDeleted}
onMessageUpdated={onMessageUpdated}
>
<Editing
allowDeleting={allowDeleting}
allowUpdating={allowUpdating}
/>
</Chat>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Allow Editing:</span>
<SelectBox
items={editingOptions}
valueExpr="key"
displayExpr="text"
inputAttr= {allowEditingLabel}
defaultValue={editingOptions[0].key}
onValueChanged={handleAllowUpdatingChange}
/>
</div>
<div className="option">
<span>Allow Deleting:</span>
<SelectBox
items={editingOptions}
valueExpr="key"
displayExpr="text"
inputAttr= {allowDeletingLabel}
defaultValue={editingOptions[0].key}
onValueChanged={handleAllowDeletingChange}
/>
</div>
</div>
</React.Fragment>
);
}
import React, { useState, useCallback } from 'react';
import { Chat, Editing } from 'devextreme-react/chat';
import { SelectBox } from 'devextreme-react/select-box';
import { Guid } from 'devextreme-react/common';
import { CustomStore, DataSource } from 'devextreme-react/common/data';
import {
currentUser,
messages as initialMessages,
allowEditingLabel,
allowDeletingLabel,
editingOptions,
} from './data.js';
const editingStrategy = {
enabled: true,
disabled: false,
custom: ({ component, message }) => {
const { items, user } = component.option();
const userId = user.id;
const lastNotDeletedMessage = items.findLast(
(item) => item.author?.id === userId && !item.isDeleted,
);
return message.id === lastNotDeletedMessage?.id;
},
};
const store = [...initialMessages];
const customStore = new CustomStore({
key: 'id',
load: async() => store,
insert: async(message) => {
store.push(message);
return message;
},
});
const dataSource = new DataSource({
store: customStore,
paginate: false,
});
export default function App() {
const [allowUpdating, setAllowUpdating] = useState(true);
const [allowDeleting, setAllowDeleting] = useState(true);
const onMessageEntered = useCallback(({ message }) => {
const newMessage = {
id: new Guid().toString(),
...message,
};
dataSource.store().push([
{
type: 'insert',
key: newMessage.id,
data: newMessage,
},
]);
}, []);
const onMessageDeleted = useCallback(({ message }) => {
dataSource.store().push([
{
type: 'update',
key: message.id,
data: { isDeleted: true },
},
]);
}, []);
const onMessageUpdated = useCallback(({ message, text }) => {
dataSource.store().push([
{
type: 'update',
key: message.id,
data: { text, isEdited: true },
},
]);
}, []);
const handleAllowUpdatingChange = useCallback((e) => {
const strategy = editingStrategy[e.value];
setAllowUpdating(() => strategy);
}, []);
const handleAllowDeletingChange = useCallback((e) => {
const strategy = editingStrategy[e.value];
setAllowDeleting(() => strategy);
}, []);
return (
<React.Fragment>
<div className="chat-container">
<Chat
height={600}
dataSource={dataSource}
user={currentUser}
reloadOnChange={false}
onMessageEntered={onMessageEntered}
onMessageDeleted={onMessageDeleted}
onMessageUpdated={onMessageUpdated}
>
<Editing
allowDeleting={allowDeleting}
allowUpdating={allowUpdating}
/>
</Chat>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Allow Editing:</span>
<SelectBox
items={editingOptions}
valueExpr="key"
displayExpr="text"
inputAttr={allowEditingLabel}
defaultValue={editingOptions[0].key}
onValueChanged={handleAllowUpdatingChange}
/>
</div>
<div className="option">
<span>Allow Deleting:</span>
<SelectBox
items={editingOptions}
valueExpr="key"
displayExpr="text"
inputAttr={allowDeletingLabel}
defaultValue={editingOptions[0].key}
onValueChanged={handleAllowDeletingChange}
/>
</div>
</div>
</React.Fragment>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import { type ChatTypes } from 'devextreme-react/chat';
import { Guid } from 'devextreme-react/common';
function getTimestamp(date, offsetMinutes = 0): number {
return date.getTime() + offsetMinutes * 60000;
}
const date = new Date();
date.setHours(0, 0, 0, 0);
export const currentUser: ChatTypes.User = {
id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3',
name: 'John Doe',
};
export const supportAgent: ChatTypes.User = {
id: 'd16d1a4c-5c67-4e20-b70e-2991c22747c3',
name: 'Support Agent',
avatarUrl: '../../../../images/petersmith.png',
};
export const messages = [
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -9),
author: supportAgent,
text: 'Hello, John!\nHow can I assist you today?',
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'Hi, I\'m having trouble accessing my account.',
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'It says my password is incorrect.',
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: currentUser,
isDeleted: true,
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: supportAgent,
text: 'I can help you with that. Can you please confirm your UserID for security purposes?',
isEdited: true,
},
];
export const allowEditingLabel = { 'aria-label': 'Allow Editing' };
export const allowDeletingLabel = { 'aria-label': 'Allow Deleting' };
export const editingOptions = [
{ text: 'Enabled', key: 'enabled' },
{ text: 'Disabled', key: 'disabled' },
{ text: 'Only the last message (custom)', key: 'custom' },
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@25.1.5/cjs',
'devextreme-react': 'npm:devextreme-react@25.1.5/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.4/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.21/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
import { Guid } from 'devextreme-react/common';
function getTimestamp(date, offsetMinutes = 0) {
return date.getTime() + offsetMinutes * 60000;
}
const date = new Date();
date.setHours(0, 0, 0, 0);
export const currentUser = {
id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3',
name: 'John Doe',
};
export const supportAgent = {
id: 'd16d1a4c-5c67-4e20-b70e-2991c22747c3',
name: 'Support Agent',
avatarUrl: '../../../../images/petersmith.png',
};
export const messages = [
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -9),
author: supportAgent,
text: 'Hello, John!\nHow can I assist you today?',
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: currentUser,
text: "Hi, I'm having trouble accessing my account.",
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'It says my password is incorrect.',
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: currentUser,
isDeleted: true,
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: supportAgent,
text: 'I can help you with that. Can you please confirm your UserID for security purposes?',
isEdited: true,
},
];
export const allowEditingLabel = { 'aria-label': 'Allow Editing' };
export const allowDeletingLabel = { 'aria-label': 'Allow Deleting' };
export const editingOptions = [
{ text: 'Enabled', key: 'enabled' },
{ text: 'Disabled', key: 'disabled' },
{ text: 'Only the last message (custom)', key: 'custom' },
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#app {
min-width: 720px;
display: flex;
gap: 20px;
}
.chat-container {
display: flex;
flex-grow: 1;
align-items: center;
justify-content: center;
}
.options {
padding: 20px;
display: flex;
flex-direction: column;
min-width: 280px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
.dx-chat {
max-width: 480px;
}
.caption {
font-size: var(--dx-font-size-sm);
font-weight: 500;
}
.dx-avatar {
border: 1px solid var(--dx-color-border);
}

<template>
<div class="chat-container">
<DxChat
:height="600"
:data-source="dataSource"
:user="currentUser"
:reload-on-change="false"
@messageEntered="onMessageEntered"
@messageDeleted="onMessageDeleted"
@messageUpdated="onMessageUpdated"
>
<DxEditing
:allow-deleting="allowDeleting"
:allow-updating="allowUpdating"
/>
</DxChat>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Allow Editing:</span>
<DxSelectBox
:items="editingOptions"
value-expr="key"
display-expr="text"
:input-attr="allowEditingLabel"
:value="selectedEditingStrategy"
@valueChanged="onAllowEditingChange"
/>
</div>
<div class="option">
<span>Allow Deleting:</span>
<DxSelectBox
:items="editingOptions"
value-expr="key"
display-expr="text"
:input-attr="allowDeletingLabel"
:value="selectedDeletingStrategy"
@valueChanged="onAllowDeletingChange"
/>
</div>
</div>
</template>
<script setup lang="ts">
import { ref, computed } from 'vue';
import { DxChat, DxEditing, type DxChatTypes } from 'devextreme-vue/chat';
import { DxSelectBox, type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import { Guid } from 'devextreme-vue/common';
import { CustomStore, DataSource } from 'devextreme-vue/common/data';
import {
messages as initialMessages,
currentUser,
editingOptions,
allowEditingLabel,
allowDeletingLabel,
} from './data.ts';
type CustomStrategyOptions = { component: DxChat['instance'], message: DxChatTypes.Message };
const store = [...initialMessages];
const customStore = new CustomStore({
key: 'id',
load: async () => store,
insert: async (message: DxChatTypes.Message) => {
store.push(message);
return message;
},
});
const dataSource = computed(() => new DataSource({
store: customStore,
paginate: false,
}));
const onMessageEntered = ({ message }: DxChatTypes.MessageEnteredEvent) => {
const newMessage = {
id: new Guid().toString(),
...message,
};
dataSource.value.store().push([
{
type: 'insert',
key: newMessage.id,
data: newMessage,
},
]);
};
const onMessageDeleted = ({ message }: DxChatTypes.MessageDeletedEvent) => {
dataSource.value.store().push([
{
type: 'update',
key: message.id,
data: { isDeleted: true },
},
]);
};
const onMessageUpdated = ({ message, text }: DxChatTypes.MessageUpdatedEvent) => {
dataSource.value.store().push([
{
type: 'update',
key: message.id,
data: { text, isEdited: true },
},
]);
};
const editingStrategy: Record<string, boolean | ((options: CustomStrategyOptions) => boolean)> = {
enabled: true,
disabled: false,
custom: ({ component, message }: CustomStrategyOptions) => {
if (!component) return false;
const { items, user } = component.option();
const userId = user?.id;
const lastNotDeletedMessage = items?.findLast(
(item: DxChatTypes.Message) => item.author?.id === userId && !item.isDeleted,
);
return message.id === lastNotDeletedMessage?.id;
},
};
const selectedEditingStrategy = ref('enabled');
const selectedDeletingStrategy = ref('enabled');
const allowUpdating = ref(editingStrategy[selectedEditingStrategy.value]);
const allowDeleting = ref(editingStrategy[selectedDeletingStrategy.value]);
const onAllowEditingChange = (event: DxSelectBoxTypes.ValueChangedEvent) => {
selectedEditingStrategy.value = event.value;
allowUpdating.value = editingStrategy[event.value];
};
const onAllowDeletingChange = (event: DxSelectBoxTypes.ValueChangedEvent) => {
selectedDeletingStrategy.value = event.value;
allowDeleting.value = editingStrategy[event.value];
};
</script>
<style scoped>
#app {
min-width: 720px;
display: flex;
gap: 20px;
}
.chat-container {
display: flex;
flex-grow: 1;
align-items: center;
justify-content: center;
}
.options {
padding: 20px;
display: flex;
flex-direction: column;
min-width: 280px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
.dx-chat {
max-width: 480px;
}
.caption {
font-size: var(--dx-font-size-sm);
font-weight: 500;
}
.option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
.dx-avatar {
border: 1px solid var(--dx-color-border);
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { Guid } from 'devextreme-vue/common';
import type { DxChatTypes } from "devextreme-vue/chat";
function getTimestamp(date: Date, offsetMinutes: number = 0) {
return date.getTime() + offsetMinutes * 60000;
}
const date = new Date();
date.setHours(0, 0, 0, 0);
export const currentUser = {
id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3',
name: 'John Doe',
};
export const supportAgent = {
id: 'd16d1a4c-5c67-4e20-b70e-2991c22747c3',
name: 'Support Agent',
avatarUrl: '../../../../images/petersmith.png',
};
export const messages: DxChatTypes.Message[] = [
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -9),
author: supportAgent,
text: 'Hello, John!\nHow can I assist you today?',
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'Hi, I\'m having trouble accessing my account.',
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'It says my password is incorrect.',
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: currentUser,
isDeleted: true,
},
{
id: new Guid().toString(),
timestamp: getTimestamp(date, -7),
author: supportAgent,
text: 'I can help you with that. Can you please confirm your UserID for security purposes?',
isEdited: true,
},
];
export const allowEditingLabel = { 'aria-label': 'Allow Editing' };
export const allowDeletingLabel = { 'aria-label': 'Allow Deleting' };
export const editingOptions = [
{ text: 'Enabled', key: 'enabled' },
{ text: 'Disabled', key: 'disabled' },
{ text: 'Only the last message (custom)', key: 'custom' },
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>